﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF;
using Microsoft.Win32;

namespace WPF_FilePicker_CustomOpenFile
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(MainWindow_Loaded);
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            c1FilePicker1.SelectedFile = new System.IO.FileInfo(Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory) + @"\Koala.jpg");
        }
    }

    public class MyC1FilePicker : C1.WPF.C1FilePicker
    {        
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            
            var btn = GetTemplateChild("Browse") as Button;
            btn.PreviewMouseDown += new MouseButtonEventHandler(btn_PreviewMouseDown);
        }

        void btn_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            e.Handled = true;
            OpenFileDialog opd = new OpenFileDialog();
            opd.Filter = this.Filter;
            opd.FileName = this.SelectedFile.ToString();
            opd.InitialDirectory = this.SelectedFile.DirectoryName;
            if (opd.ShowDialog() == true)
            {
                this.SelectedFile = new System.IO.FileInfo(opd.FileName);
            }
        }       
    }
}
